
Foreman - Bug #3515

Associated resources not found by ID causes 500 Internal Server Error

10/25/2013 12:58 PM - Dominic Cleal

Status: Closed   

Priority: Normal   

Assignee: Daniel Lobato Garcia   

Category: API   

Target version: 1.4.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Description of problem:

making call of hammer cli:

`hammer --output base subnet create --name "allparams" --network "251.10.10.11" --mask "255.255.25

5.0" --gateway "251.10.10.255" --dns-primary "251.10.11.255" --dns-secondary "251.10.12.255" --fro

m "251.10.10.10" --to "251.10.10.12" --vlanid "2" --domain-ids "1"` just fails with:

===

Could not create the subnet:

  Error: 500 Internal Server Error

 Actual results:

500 - ISE

Expected results:

no exception. subnet needs to be created. Even if there is any error: proper message should be returned back.

Foreman production.log:

Started POST "/foreman/api/subnets" for 127.0.0.1 at 2013-10-25 06:23:19 -0400

Processing by Api::V1::SubnetsController#create as JSON

  Parameters: {"subnet"=>{"dns_secondary"=>"251.10.12.255", "network"=>"251.10.10.11", "from"=>"25

1.10.10.10", "mask"=>"255.255.255.0", "vlanid"=>"2", "to"=>"251.10.10.12", "domain_ids"=>["1"], "g

ateway"=>"251.10.10.255", "dns_primary"=>"251.10.11.255", "name"=>"allparams"}}

Authorized user admin(Admin User)

Couldn't find Domain with id=1 (ActiveRecord::RecordNotFound)

 (https://bugzilla.redhat.com/show_bug.cgi?id=1023393)

Related issues:

Blocks Hammer CLI - Bug #3915: Hammer does not handle 404s well Closed 12/18/2013

Associated revisions

Revision 46338cd7 - 01/17/2014 09:24 AM - Daniel Lobato Garcia

fixes #3515 - API handles not found objects with 404

Revision 92b8e9b1 - 01/20/2014 07:09 PM - Daniel Lobato Garcia

fixes #3515 - API handles not found objects with 404

(cherry picked from commit 46338cd73c542ecc3aa045b45e831434792c710e)

History

#1 - 11/12/2013 01:12 PM - Anonymous

- Target version set to 1.10.0
https://bugzilla.redhat.com/show_bug.cgi?id=1023393


#2 - 11/25/2013 04:57 PM - Tomáš Strachota

- Project changed from Hammer CLI to Foreman

- Category changed from Foreman commands (obsolete) to API

This is actually problem on api side. I've switched the project/category of the bug.

Api should return 404 with better message when an associated resource is not found.

From the foreman log:

 Domain Load (0.1ms)  SELECT "domains".* FROM "domains" WHERE "domains"."id" = $1 ORDER BY domains.name LIMIT 

1  [["id", 83]]

Couldn't find Domain with id=83 (ActiveRecord::RecordNotFound)

...

  Rendered api/v2/errors/standard_error.json.rabl (0.6ms)

Completed 500 Internal Server Error in 19.5ms (Views: 9.7ms | ActiveRecord: 1.7ms)

#3 - 12/04/2013 01:12 PM - Anonymous

- Target version changed from 1.10.0 to 1.9.3

#4 - 12/17/2013 05:43 PM - Daniel Lobato Garcia

https://github.com/theforeman/foreman/pull/1098

#5 - 12/17/2013 08:14 PM - Dominic Cleal

- Status changed from New to Ready For Testing

- Assignee set to Daniel Lobato Garcia

#6 - 12/18/2013 06:27 PM - Daniel Lobato Garcia

- Related to Bug #3915: Hammer does not handle 404s well added

#7 - 12/18/2013 06:27 PM - Daniel Lobato Garcia

- Related to deleted (Bug #3915: Hammer does not handle 404s well)

#8 - 12/18/2013 06:27 PM - Daniel Lobato Garcia

- Blocks Bug #3915: Hammer does not handle 404s well added

#9 - 01/09/2014 02:09 PM - Anonymous

- Target version changed from 1.9.3 to 1.9.2

#10 - 01/17/2014 09:25 AM - Dominic Cleal

- translation missing: en.field_release set to 2

#11 - 01/17/2014 12:31 PM - Daniel Lobato Garcia

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 46338cd73c542ecc3aa045b45e831434792c710e.
